| package |
package := Package name: 'MSXMLImport'.
package paxVersion: 0;
	basicComment: ''.


package classNames
	add: #MSXMLIXMLHttpRequest;
	yourself.

package globalNames
	add: #MSXMLConstants;
	add: #MSXMLLib;
	yourself.

package binaryGlobalNames: (Set new
	add: #MSXMLLib;
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\ActiveX\Automation\ActiveX Automation';
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Object Arts\Dolphin\ActiveX\COM\OLE COM';
	yourself).

package!

"Class Definitions"!

IDispatch subclass: #MSXMLIXMLHttpRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'MSXMLConstants'
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

Smalltalk at: #MSXMLConstants put: (PoolConstantsDictionary named: #MSXMLConstants)!
MSXMLConstants at: 'NODE_ATTRIBUTE' put: 16r2!
MSXMLConstants at: 'NODE_CDATA_SECTION' put: 16r4!
MSXMLConstants at: 'NODE_COMMENT' put: 16r8!
MSXMLConstants at: 'NODE_DOCUMENT' put: 16r9!
MSXMLConstants at: 'NODE_DOCUMENT_FRAGMENT' put: 16rB!
MSXMLConstants at: 'NODE_DOCUMENT_TYPE' put: 16rA!
MSXMLConstants at: 'NODE_ELEMENT' put: 16r1!
MSXMLConstants at: 'NODE_ENTITY' put: 16r6!
MSXMLConstants at: 'NODE_ENTITY_REFERENCE' put: 16r5!
MSXMLConstants at: 'NODE_INVALID' put: 16r0!
MSXMLConstants at: 'NODE_NOTATION' put: 16rC!
MSXMLConstants at: 'NODE_PROCESSING_INSTRUCTION' put: 16r7!
MSXMLConstants at: 'NODE_TEXT' put: 16r3!
MSXMLConstants at: 'XMLELEMTYPE_COMMENT' put: 16r2!
MSXMLConstants at: 'XMLELEMTYPE_DOCUMENT' put: 16r3!
MSXMLConstants at: 'XMLELEMTYPE_DTD' put: 16r4!
MSXMLConstants at: 'XMLELEMTYPE_ELEMENT' put: 16r0!
MSXMLConstants at: 'XMLELEMTYPE_OTHER' put: 16r6!
MSXMLConstants at: 'XMLELEMTYPE_PI' put: 16r5!
MSXMLConstants at: 'XMLELEMTYPE_TEXT' put: 16r1!
MSXMLConstants shrink!

"Classes"!

MSXMLIXMLHttpRequest guid: (IID fromString: '{ED8C108D-4349-11D2-91A4-00C04F7969E8}')!
MSXMLIXMLHttpRequest comment: '<MSXMLIXMLHttpRequest> is a wrapper class for the COM interface ''MSXML.IXMLHttpRequest'' generated from type information in the ''Microsoft XML, version 2.0'' library. It contains methods to invoke the member functions exposed by that interface.

The type library contains the following helpstring for this interface
	"IXMLHttpRequest Interface"

Warning: This comment was automatically generated from the interface''s type information, but any changes made here will not be overwritten if the wrapper class is regenerated.

IDL definition follows:

[
	object, 
	uuid(ED8C108D-4349-11D2-91A4-00C04F7969E8), 
	helpstring("IXMLHttpRequest Interface"), 
	dual
]
interface IXMLHttpRequest : IDispatch {
	[id(0x00000001), helpstring("Open HTTP connection")]
	HRESULT __stdcall open(
		[in] BSTR bstrMethod,
		[in] BSTR bstrUrl,
		[in, optional] VARIANT varAsync,
		[in, optional] VARIANT bstrUser,
		[in, optional] VARIANT bstrPassword);
	[id(0x00000002), helpstring("Add HTTP request header")]
	HRESULT __stdcall setRequestHeader(
		[in] BSTR bstrHeader,
		[in] BSTR bstrValue);
	[id(0x00000003), helpstring("Get HTTP response header")]
	HRESULT __stdcall getResponseHeader(
		[in] BSTR bstrHeader,
		[out, retval] BSTR* pbstrValue);
	[id(0x00000004), helpstring("Get all HTTP response headers")]
	HRESULT __stdcall getAllResponseHeaders(
		[out, retval] BSTR* pbstrHeaders);
	[id(0x00000005), helpstring("Send HTTP request")]
	HRESULT __stdcall send(
		[in, optional] VARIANT varBody);
	[id(0x00000006), helpstring("Abort HTTP request")]
	HRESULT __stdcall abort();
	[id(0x00000007), propget, helpstring("Get HTTP status code")]
	HRESULT __stdcall status(
		[out, retval] long* plStatus);
	[id(0x00000008), propget, helpstring("Get HTTP status text")]
	HRESULT __stdcall statusText(
		[out, retval] BSTR* pbstrStatus);
	[id(0x00000009), propget, helpstring("Get response body")]
	HRESULT __stdcall responseXML(
		[out, retval] IDispatch** ppBody);
	[id(0x0000000a), propget, helpstring("Get response body")]
	HRESULT __stdcall responseText(
		[out, retval] BSTR* pbstrBody);
	[id(0x0000000b), propget, helpstring("Get response body")]
	HRESULT __stdcall responseBody(
		[out, retval] VARIANT* pvarBody);
	[id(0x0000000c), propget, helpstring("Get response body")]
	HRESULT __stdcall responseStream(
		[out, retval] VARIANT* pvarBody);
	[id(0x0000000d), propget, helpstring("Get ready state")]
	HRESULT __stdcall readyState(
		[out, retval] long* plState);
	[id(0x0000000e), propput, helpstring("Register a complete event handler")]
	HRESULT __stdcall onreadystatechange(
		[in] IDispatch* arg1);
};
'!
!MSXMLIXMLHttpRequest categoriesForClass!COM-Interfaces!MSXML-Interfaces! !
!MSXMLIXMLHttpRequest methodsFor!

abort
	"Invoke the abort() method of the COM object.
	Helpstring: Abort HTTP request"

	^self Abort
!

Abort
	"Private - Invoke the abort() method of the COM object.
	Helpstring: Abort HTTP request

		HRESULT __stdcall abort();"

	<virtual stdcall: hresult 13>
	^self invalidCall
!

get_readyState: plState
	"Private - Get the value of the 'readyState' property of the receiver.

		HRESULT __stdcall readyState(
			[out, retval] long* plState);"

	<virtual stdcall: hresult 20 sdword*>
	^self invalidCall
!

get_responseBody: pvarBody
	"Private - Get the value of the 'responseBody' property of the receiver.

		HRESULT __stdcall responseBody(
			[out, retval] VARIANT* pvarBody);"

	<virtual stdcall: hresult 18 variant*>
	^self invalidCall
!

get_responseStream: pvarBody
	"Private - Get the value of the 'responseStream' property of the receiver.

		HRESULT __stdcall responseStream(
			[out, retval] VARIANT* pvarBody);"

	<virtual stdcall: hresult 19 variant*>
	^self invalidCall
!

get_responseText: pbstrBody
	"Private - Get the value of the 'responseText' property of the receiver.

		HRESULT __stdcall responseText(
			[out, retval] BSTR* pbstrBody);"

	<virtual stdcall: hresult 17 bstr*>
	^self invalidCall
!

get_responseXML: ppBody
	"Private - Get the value of the 'responseXML' property of the receiver.

		HRESULT __stdcall responseXML(
			[out, retval] IDispatch** ppBody);"

	<virtual stdcall: hresult 16 IDispatch**>
	^self invalidCall
!

get_status: plStatus
	"Private - Get the value of the 'status' property of the receiver.

		HRESULT __stdcall status(
			[out, retval] long* plStatus);"

	<virtual stdcall: hresult 14 sdword*>
	^self invalidCall
!

get_statusText: pbstrStatus
	"Private - Get the value of the 'statusText' property of the receiver.

		HRESULT __stdcall statusText(
			[out, retval] BSTR* pbstrStatus);"

	<virtual stdcall: hresult 15 bstr*>
	^self invalidCall
!

getAllResponseHeaders
	"Answer the <BSTR> result of invoking the getAllResponseHeaders() method of the COM object.
	Helpstring: Get all HTTP response headers"

	| answer |
	answer := BSTR new.
	self GetAllResponseHeaders: answer.
	^answer asObject
!

GetAllResponseHeaders: pbstrHeaders
	"Private - Invoke the getAllResponseHeaders() method of the COM object.
	Helpstring: Get all HTTP response headers

		HRESULT __stdcall getAllResponseHeaders(
			[out, retval] BSTR* pbstrHeaders);"

	<virtual stdcall: hresult 11 bstr*>
	^self invalidCall
!

getResponseHeader: bstrHeader
	"Answer the <BSTR> result of invoking the getResponseHeader() method of the COM object.
	Helpstring: Get HTTP response header"

	| answer |
	answer := BSTR new.
	self
		GetResponseHeader: bstrHeader
		pbstrValue: answer.
	^answer asObject
!

GetResponseHeader: bstrHeader pbstrValue: pbstrValue
	"Private - Invoke the getResponseHeader() method of the COM object.
	Helpstring: Get HTTP response header

		HRESULT __stdcall getResponseHeader(
			[in] BSTR bstrHeader,
			[out, retval] BSTR* pbstrValue);"

	<virtual stdcall: hresult 10 bstr bstr*>
	^self invalidCall
!

onreadystatechange: arg1
	"Set the 'onreadystatechange' property of the receiver to the <IDispatch*> value of the argument.
	Helpstring: Register a complete event handler"

	self put_onreadystatechange: arg1
!

open: bstrMethod bstrUrl: bstrUrl
	"Invoke the open() method of the COM object.
	Default values are passed for all optional parameters."

	^self
		 open: bstrMethod
		 bstrUrl: bstrUrl
		 varAsync: VARIANT unspecified
		 bstrUser: VARIANT unspecified
		 bstrPassword: VARIANT unspecified!

open: bstrMethod bstrUrl: bstrUrl varAsync: varAsync bstrUser: bstrUser bstrPassword: bstrPassword
	"Invoke the open() method of the COM object.
	Helpstring: Open HTTP connection"

	^self
		Open: bstrMethod
		bstrUrl: bstrUrl
		varAsync: varAsync asVariant
		bstrUser: bstrUser asVariant
		bstrPassword: bstrPassword asVariant
!

Open: bstrMethod bstrUrl: bstrUrl varAsync: varAsync bstrUser: bstrUser bstrPassword: bstrPassword
	"Private - Invoke the open() method of the COM object.
	Helpstring: Open HTTP connection

		HRESULT __stdcall open(
			[in] BSTR bstrMethod,
			[in] BSTR bstrUrl,
			[in, optional] VARIANT varAsync,
			[in, optional] VARIANT bstrUser,
			[in, optional] VARIANT bstrPassword);"

	<virtual stdcall: hresult 8 bstr bstr variant variant variant>
	^self invalidCall
!

put_onreadystatechange: arg1
	"Private - Set the value of the 'onreadystatechange' property of the object wrapped by the 
	 receiver to the <IDispatch*> argument, arg1.

		HRESULT __stdcall onreadystatechange(
			[in] IDispatch* arg1);"

	<virtual stdcall: hresult 21 IDispatch*>
	^self invalidCall
!

readyState
	"Answer the <sdword> value of the 'readyState' property of the receiver.
	Helpstring: Get ready state"

	| answer |
	answer := (SDWORD new).
	self get_readyState: answer.
	^answer asObject
!

responseBody
	"Answer the <variant> value of the 'responseBody' property of the receiver.
	Helpstring: Get response body"

	| answer |
	answer := VARIANT new.
	self get_responseBody: answer.
	^answer asObject
!

responseStream
	"Answer the <variant> value of the 'responseStream' property of the receiver.
	Helpstring: Get response body"

	| answer |
	answer := VARIANT new.
	self get_responseStream: answer.
	^answer asObject
!

responseText
	"Answer the <bstr> value of the 'responseText' property of the receiver.
	Helpstring: Get response body"

	| answer |
	answer := BSTR new.
	self get_responseText: answer.
	^answer asObject
!

responseXML
	"Answer the <IDispatch> value of the 'responseXML' property of the receiver.
	Helpstring: Get response body"

	| answer |
	answer := IDispatch newPointer.
	self get_responseXML: answer.
	^answer asObject
!

send
	"Invoke the send() method of the COM object.
	Default values are passed for all optional parameters."

	^self send: VARIANT unspecified!

send: varBody
	"Invoke the send() method of the COM object.
	Helpstring: Send HTTP request"

	^self Send: varBody asVariant
!

Send: varBody
	"Private - Invoke the send() method of the COM object.
	Helpstring: Send HTTP request

		HRESULT __stdcall send(
			[in, optional] VARIANT varBody);"

	<virtual stdcall: hresult 12 variant>
	^self invalidCall
!

setRequestHeader: bstrHeader bstrValue: bstrValue
	"Invoke the setRequestHeader() method of the COM object.
	Helpstring: Add HTTP request header"

	^self
		SetRequestHeader: bstrHeader
		bstrValue: bstrValue
!

SetRequestHeader: bstrHeader bstrValue: bstrValue
	"Private - Invoke the setRequestHeader() method of the COM object.
	Helpstring: Add HTTP request header

		HRESULT __stdcall setRequestHeader(
			[in] BSTR bstrHeader,
			[in] BSTR bstrValue);"

	<virtual stdcall: hresult 9 bstr bstr>
	^self invalidCall
!

status
	"Answer the <sdword> value of the 'status' property of the receiver.
	Helpstring: Get HTTP status code"

	| answer |
	answer := (SDWORD new).
	self get_status: answer.
	^answer asObject
!

statusText
	"Answer the <bstr> value of the 'statusText' property of the receiver.
	Helpstring: Get HTTP status text"

	| answer |
	answer := BSTR new.
	self get_statusText: answer.
	^answer asObject
! !
!MSXMLIXMLHttpRequest categoriesFor: #abort!**auto generated**!methods!public! !
!MSXMLIXMLHttpRequest categoriesFor: #Abort!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #get_readyState:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #get_responseBody:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #get_responseStream:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #get_responseText:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #get_responseXML:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #get_status:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #get_statusText:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #getAllResponseHeaders!**auto generated**!methods!public! !
!MSXMLIXMLHttpRequest categoriesFor: #GetAllResponseHeaders:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #getResponseHeader:!**auto generated**!methods!public! !
!MSXMLIXMLHttpRequest categoriesFor: #GetResponseHeader:pbstrValue:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #onreadystatechange:!**auto generated**!properties!public! !
!MSXMLIXMLHttpRequest categoriesFor: #open:bstrUrl:!**auto generated**!methods!public! !
!MSXMLIXMLHttpRequest categoriesFor: #open:bstrUrl:varAsync:bstrUser:bstrPassword:!**auto generated**!methods!public! !
!MSXMLIXMLHttpRequest categoriesFor: #Open:bstrUrl:varAsync:bstrUser:bstrPassword:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #put_onreadystatechange:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #readyState!**auto generated**!properties!public! !
!MSXMLIXMLHttpRequest categoriesFor: #responseBody!**auto generated**!properties!public! !
!MSXMLIXMLHttpRequest categoriesFor: #responseStream!**auto generated**!properties!public! !
!MSXMLIXMLHttpRequest categoriesFor: #responseText!**auto generated**!properties!public! !
!MSXMLIXMLHttpRequest categoriesFor: #responseXML!**auto generated**!properties!public! !
!MSXMLIXMLHttpRequest categoriesFor: #send!**auto generated**!methods!public! !
!MSXMLIXMLHttpRequest categoriesFor: #send:!**auto generated**!methods!public! !
!MSXMLIXMLHttpRequest categoriesFor: #Send:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #setRequestHeader:bstrValue:!**auto generated**!methods!public! !
!MSXMLIXMLHttpRequest categoriesFor: #SetRequestHeader:bstrValue:!**auto generated**!COM Interfaces-IXMLHttpRequest!private! !
!MSXMLIXMLHttpRequest categoriesFor: #status!**auto generated**!properties!public! !
!MSXMLIXMLHttpRequest categoriesFor: #statusText!**auto generated**!properties!public! !

MSXMLIXMLHttpRequest methodProtocol: #'MSXML.IXMLHttpRequest' attributes: #() selectors: #(#Abort #get_readyState: #get_responseBody: #get_responseStream: #get_responseText: #get_responseXML: #get_status: #get_statusText: #GetAllResponseHeaders: #GetResponseHeader:pbstrValue: #Open:bstrUrl:varAsync:bstrUser:bstrPassword: #put_onreadystatechange: #Send: #SetRequestHeader:bstrValue:)!

!MSXMLIXMLHttpRequest class methodsFor!

clsid
	"Private - Answer the CLSID of the coclass (XMLHTTPRequest) for which the receiver is the default interface."

	^CLSID fromString: '{ED8C108E-4349-11D2-91A4-00C04F7969E8}'
!

defineFunctions
	"Declare the virtual function table for the COM interface 'MSXML.IXMLHttpRequest'
		MSXMLIXMLHttpRequest defineTemplate"

	self
		defineFunction: #Open:bstrUrl:varAsync:bstrUser:bstrPassword:
			argumentTypes: 'bstr bstr variant variant variant';
		defineFunction: #SetRequestHeader:bstrValue:
			argumentTypes: 'bstr bstr';
		defineFunction: #GetResponseHeader:pbstrValue:
			argumentTypes: 'bstr bstr*';
		defineFunction: #GetAllResponseHeaders:
			argumentTypes: 'bstr*';
		defineFunction: #Send:
			argumentTypes: 'variant';
		defineFunction: #Abort;
		defineFunction: #get_status:
			argumentTypes: 'sdword*';
		defineFunction: #get_statusText:
			argumentTypes: 'bstr*';
		defineFunction: #get_responseXML:
			argumentTypes: 'IDispatch**';
		defineFunction: #get_responseText:
			argumentTypes: 'bstr*';
		defineFunction: #get_responseBody:
			argumentTypes: 'variant*';
		defineFunction: #get_responseStream:
			argumentTypes: 'variant*';
		defineFunction: #get_readyState:
			argumentTypes: 'sdword*';
		defineFunction: #put_onreadystatechange:
			argumentTypes: 'IDispatch*'
!

initializeTypeLib
	"Private - Establish a connection to the receiver's type library.
		MSXMLIXMLHttpRequest initializeTypeLib"

	typeLib := MSXMLLib! !
!MSXMLIXMLHttpRequest class categoriesFor: #clsid!**auto generated**!constants!private! !
!MSXMLIXMLHttpRequest class categoriesFor: #defineFunctions!**auto generated**!initializing!public! !
!MSXMLIXMLHttpRequest class categoriesFor: #initializeTypeLib!**auto generated**!initializing!private! !

"Binary Globals"!

MSXMLLib := Object fromBinaryStoreBytes: 
(ByteArray fromBase64String: 'IVNUQiAxIEYJFQABAAAAQVhUeXBlTGlicmFyeUFuYWx5emVyAAAAAAYCCQBJVHlwZUxpYjIAAAAA
AAAAAAAAAAAGAQgAVExJQkFUVFIAAAAAcgAAACAAAADiDD7WoqDQEZwCAMBPyZyOAAAAAAEAAAAC
AAAACAAAAFIAAAAFAAAATVNYTUxBAAAAUgAAAAUAAABNU1hNTLoAAAAAAAAAUgAAAAgAAABNU1hN
TExpYlIAAAAOAAAATVNYTUxDb25zdGFudHPqAAAAAAAAAPAAAABiAAAAAgAAAFIAAAAEAAAAR1VJ
RLoAAAAAAAAAUgAAAAQAAABHVUlEAAAAAA==')!

"Resources"!

